# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Andre Desgualdo Pereira desgua@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

from gi.repository import Gtk # pylint: disable=E0611

from sbk_lib.helpers import get_builder

from sbk.NewbkbDialog import NewbkbDialog

import os
import gettext
from gettext import gettext as _
gettext.textdomain('sbk')

class NewbkaDialog(Gtk.Dialog):
    __gtype_name__ = "NewbkaDialog"

    def __new__(cls):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated NewbkaDialog object.
        """
        builder = get_builder('NewbkaDialog')
        new_object = builder.get_object('newbka_dialog')
        new_object.finish_initializing(builder)
        return new_object

    def finish_initializing(self, builder):
        """Called when we're finished initializing.

        finish_initalizing should be called after parsing the ui definition
        and creating a NewbkaDialog object with it in order to
        finish initializing the start of the new NewbkaDialog
        instance.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.ui = builder.get_ui(self)

        # set_text
        self.label = builder.get_object("label3") 
        builder.connect_signals(self)   
        # /set text
        

    def on_size_pressed(self, widget, data=None): 
        self.label.set_text("Please wait a moment...")

    def on_size_clicked(self, widget, data=None): 

        # escluded from backup:
        os.system("cd ~ && ls > ~/.config/sbk/excluded")
        os.system("echo '.sudo_as_admin_successful\n.gvfs\n.Private\n.ecryptfs\n.xsession-errors\n.Xauthority\n.ICEauthority\n.esd_auth\n.config/sbk' >> ~/.config/sbk/excluded")
        
        if self.builder.get_object("cache").get_active() == True:
            os.system("cd ~ && sed -i 's/\*\*cache\*\*//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")
            os.system("cd ~ && sed -i 's/\*\*Cache\*\*//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")            
        else:
            os.system("echo '**cache**\n**Cache**' >> ~/.config/sbk/excluded")

        if self.builder.get_object("thumbnails").get_active() == True:
            os.system("cd ~ && sed -i 's/\*\*thumbs\*\*//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")
            os.system("cd ~ && sed -i 's/.thumbnails//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")                        
        else:
            os.system("echo '.thumbnails\n**thumbs**' >> ~/.config/sbk/excluded")        

        if self.builder.get_object("trash").get_active() == True:
            os.system("cd ~ && sed -i 's/.local\/share\/Trash//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")
        else:
            os.system("echo '.local/share/Trash' >> ~/.config/sbk/excluded")            

        # get backup folder and exclude:
        bk = open(os.environ['HOME']+'/.config/sbk/backupfolder', 'w')
        bk.write(self.builder.get_object("filechooserbutton1").get_filename())
        bk.close()

        os.system("cat ~/.config/sbk/backupfolder >> ~/.config/sbk/excluded")
        
        # calculate size:                    
        os.system("cd ~ && a=`rsync -arbvn --exclude-from='.config/sbk/excluded' --delete ~/ /tmp/sbk/ | grep 'total size' | sed 's/total size is //' | sed 's/ speedup.*//'` ; echo `echo $a / 2000000 | bc` > ~/.config/sbk/estimatedsize")
        size = open(os.environ['HOME']+'/.config/sbk/estimatedsize').read()
        size = size[:-1]
        self.label.set_text("The estimated backup size is %s MB." % size)


    def on_button2_clicked(self, widget, data=None): 
    
        # escluded from backup:
        os.system("cd ~ && ls > ~/.config/sbk/excluded")
        os.system("echo '.sudo_as_admin_successful\n.gvfs\n.Private\n.ecryptfs\n.xsession-errors\n.Xauthority\n.ICEauthority\n.esd_auth\n.config/sbk/bk' >> ~/.config/sbk/excluded")
        
        if self.builder.get_object("cache").get_active() == True:
            os.system("cd ~ && sed -i 's/\*\*cache\*\*//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")
            os.system("cd ~ && sed -i 's/\*\*Cache\*\*//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")            
        else:
            os.system("echo '**cache**\n**Cache**' >> ~/.config/sbk/excluded")

        if self.builder.get_object("thumbnails").get_active() == True:
            os.system("cd ~ && sed -i 's/\*\*thumbs\*\*//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")
            os.system("cd ~ && sed -i 's/.thumbnails//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")                        
        else:
            os.system("echo '.thumbnails\n**thumbs**' >> ~/.config/sbk/excluded")        

        if self.builder.get_object("trash").get_active() == True:
            os.system("cd ~ && sed -i 's/.local\/share\/Trash//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")
        else:
            os.system("echo '.local/share/Trash' >> ~/.config/sbk/excluded")            
        
        # get backup folder and exclude:
        bk = open(os.environ['HOME']+'/.config/sbk/backupfolder', 'w')
        bk.write(self.builder.get_object("filechooserbutton1").get_filename())
        bk.close()

        os.system("cat ~/.config/sbk/backupfolder >> ~/.config/sbk/excluded")
        
        # backup script:
        os.system("touch ~/.config/sbk/backscript")
        backscript = open(os.environ['HOME']+'/.config/sbk/backscript', 'w')    
        backscript.write("""#!/bin/bash
echo "no" > ~/.config/sbk/backdone
entry=$(cat ~/.config/sbk/backupfolder)
entry=$(echo $entry/)
a=$(xdg-user-dir HOME)
d=$(date '+%Y.%m.%d_%H-%M')
rsync -arbv --exclude-from="$a/.config/sbk/excluded" --delete "$a/" "$a/.config/sbk/bk"
cd $a/.config/sbk
find $a/.config/sbk/bk/ -name '*~' -exec rm '{}' \;
find $a/.config/sbk/bk/ -type d -empty -exec rmdir {} \;
tar -cvz bk/ -f $entry/$d.sbk
rm -r $a/.config/sbk/bk/
echo "ok" > ~/.config/sbk/backdone 
exit 0
        """)
        backscript.close()

        os.system("gnome-terminal -e 'bash -c \"sh ~/.config/sbk/backscript ; exit ; exec bash\"'")

        NewbkbDialog().show()

# Creating the configuration folder and file:

os.system("mkdir -p ~/.config/sbk/bk")



if __name__ == "__main__":
    dialog = NewbkaDialog()
    dialog.show()
    Gtk.main()
