# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Andre Desgualdo Pereira desgua@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

from gi.repository import Gtk # pylint: disable=E0611

from sbk_lib.helpers import get_builder
from sbk.RestbDialog import RestbDialog
from sbk.RestcDialog import RestcDialog
from sbk.RestdDialog import RestdDialog

import os 
import gettext
from gettext import gettext as _
gettext.textdomain('sbk')

def restore():

    # restore script: 
    os.system("touch ~/.config/sbk/restscript")
    restscript = open(os.environ['HOME']+'/.config/sbk/restscript', 'w')    
    restscript.write("""#!/bin/bash
echo "no" > ~/.config/sbk/restdone
a=$(xdg-user-dir HOME)
b=$(cat ~/.config/sbk/backupfile)
cd $a/.config/sbk/
rm -r $a/.config/sbk/bk/
tar -xz -f $b
rsync -arbv ./bk/ "$a/"
rm -r $a/.config/sbk/bk/
echo "ok" > ~/.config/sbk/restdone 
exit 0
    """)
    restscript.close()

    os.system("gnome-terminal -e 'bash -c \"sh ~/.config/sbk/restscript ; exit ; exec bash\"'")



class RestaDialog(Gtk.Dialog):
    __gtype_name__ = "RestaDialog"

    def __new__(cls):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated RestaDialog object.
        """
        builder = get_builder('RestaDialog')
        new_object = builder.get_object('resta_dialog')
        new_object.finish_initializing(builder)
        return new_object

    def finish_initializing(self, builder):
        """Called when we're finished initializing.

        finish_initalizing should be called after parsing the ui definition
        and creating a RestaDialog object with it in order to
        finish initializing the start of the new RestaDialog
        instance.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.ui = builder.get_ui(self)
        

        # File filter
        dialog = builder.get_object("filechooserbutton1")
        filter = Gtk.FileFilter()
        filter.set_name("Sbk")
        filter.add_pattern("*.sbk")
        dialog.add_filter(filter)
        filter = Gtk.FileFilter()        
        filter.set_name("All Files")
        filter.add_pattern("*")
        dialog.add_filter(filter)


    
        

    def on_btn_ok_clicked(self, widget, data=None):
    

        # get backup file name:
        bk = open(os.environ['HOME']+'/.config/sbk/backupfile', 'w')
        bk.write(self.builder.get_object("filechooserbutton1").get_filename())
        bk.close()

        # check ownership:
        
        os.system("touch ~/.config/sbk/ownerscript")
        ownerscript = open(os.environ['HOME']+'/.config/sbk/ownerscript', 'w')    
        ownerscript.write("""#!/bin/bash
entry=`cat ~/.config/sbk/backupfile`
ls -l $entry | awk '{ print $3 }' | grep `whoami` > ~/.config/sbk/ownership
exit 0
        """)
        ownerscript.close()
        os.system("sh ~/.config/sbk/ownerscript")
        
        
        # check if the user is in the sudoers:
        os.system("id | grep 'sudo' > ~/.config/sbk/adm")
        
        # combine the checks above:
        
        ownership = open(os.environ['HOME']+'/.config/sbk/ownership').readlines()
        sudo = open(os.environ['HOME']+'/.config/sbk/adm').readlines()                
        print ownership
        print sudo        
        
        if ownership == [] and sudo == []: # the user is *not* the owner and is *not* in the sudoers
            RestbDialog().show()
            
        elif ownership == [] and sudo != []: # the user is *not* owner and is in the sudoers
            os.system("echo no > ~/.config/sbk/ownershiptoken")
            RestcDialog().show()
            
        else: # the user is the owner
            restore()
            RestdDialog().show()

    def on_btn_cancel_clicked(self, widget, data=None):
        self.destroy()


if __name__ == "__main__":
    dialog = RestaDialog()
    dialog.show()
    Gtk.main()
