# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Andre Desgualdo Pereira desgua@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

from gi.repository import Gtk # pylint: disable=E0611

from sbk_lib.helpers import get_builder

import os
import gettext
from gettext import gettext as _
gettext.textdomain('sbk')

class RestdDialog(Gtk.Dialog):
    __gtype_name__ = "RestdDialog"

    def __new__(cls):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated RestdDialog object.
        """
        builder = get_builder('RestdDialog')
        new_object = builder.get_object('restd_dialog')
        new_object.finish_initializing(builder)
        return new_object

    def finish_initializing(self, builder):
        """Called when we're finished initializing.

        finish_initalizing should be called after parsing the ui definition
        and creating a RestdDialog object with it in order to
        finish initializing the start of the new RestdDialog
        instance.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.ui = builder.get_ui(self)

        # set_text
        self.label = builder.get_object("label2") 
        builder.connect_signals(self)   
        # /set text


    def on_yes_pressed(self, widget, data=None): 
        self.label.set_text("Please wait a moment. When finished this window will close.")
        

    def on_yes_clicked(self, widget, data=None):
        while True:
            os.system("sleep 1")
            restdone = open(os.environ['HOME']+'/.config/sbk/restdone').readlines()
            if restdone == ['ok\n']:
                break

        os.system("gnome-session-quit")
        quit()

    def on_no_clicked(self, widget, data=None):
        quit()



if __name__ == "__main__":
    dialog = RestdDialog()
    dialog.show()
    Gtk.main()
