# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Andre Desgualdo Pereira desgua@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import gettext
from gettext import gettext as _
gettext.textdomain('sbk')

from gi.repository import Gtk # pylint: disable=E0611
import logging
logger = logging.getLogger('sbk')

from sbk_lib import Window
from sbk.AboutSbkDialog import AboutSbkDialog
from sbk.PreferencesSbkDialog import PreferencesSbkDialog
from sbk.NewbkaDialog import NewbkaDialog
from sbk.UpdbkaDialog import UpdbkaDialog
from sbk.RestaDialog import RestaDialog

# See sbk_lib.Window.py for more details about how this class works
class SbkWindow(Window):
    __gtype_name__ = "SbkWindow"
    
    def finish_initializing(self, builder): # pylint: disable=E1002
        """Set up the main window"""
        super(SbkWindow, self).finish_initializing(builder)

        self.AboutDialog = AboutSbkDialog
        self.PreferencesDialog = PreferencesSbkDialog

        # Code for other initialization actions should be added here.
    
    def on_newbkbutton_clicked(self, widget, data=None): 
        NewbkaDialog().show()

    
    def on_upbkbutton_clicked(self, widget, data=None): 
        UpdbkaDialog().show()

    
    def on_restbutton_clicked(self, widget, data=None): 
        RestaDialog().show()
