# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Andre Desgualdo Pereira desgua@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

from gi.repository import Gtk # pylint: disable=E0611

from sbk_lib.helpers import get_builder
from sbk.UpdbkbDialog import UpdbkbDialog
import os
import gettext
from gettext import gettext as _
gettext.textdomain('sbk')

class UpdbkaDialog(Gtk.Dialog):
    __gtype_name__ = "UpdbkaDialog"

    def __new__(cls):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated UpdbkaDialog object.
        """
        builder = get_builder('UpdbkaDialog')
        new_object = builder.get_object('updbka_dialog')
        new_object.finish_initializing(builder)
        return new_object

    def finish_initializing(self, builder):
        """Called when we're finished initializing.

        finish_initalizing should be called after parsing the ui definition
        and creating a UpdbkaDialog object with it in order to
        finish initializing the start of the new UpdbkaDialog
        instance.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.ui = builder.get_ui(self)

        # File filter
        dialog = builder.get_object("filechooserbutton1")
        filter = Gtk.FileFilter()
        filter.set_name("Sbk")
        filter.add_pattern("*.sbk")
        dialog.add_filter(filter)
        filter = Gtk.FileFilter()        
        filter.set_name("All Files")
        filter.add_pattern("*")
        dialog.add_filter(filter)

        

    def on_button2_clicked(self, widget, data=None):

        # escluded from backup:
        os.system("cd ~ && ls > ~/.config/sbk/excluded")
        os.system("echo '.sudo_as_admin_successful\n.gvfs\n.Private\n.ecryptfs\n.xsession-errors\n.Xauthority\n.ICEauthority\n.esd_auth\n.config/sbk' >> ~/.config/sbk/excluded")
        
        if self.builder.get_object("cache").get_active() == True:
            os.system("cd ~ && sed -i 's/\*\*cache\*\*//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")
            os.system("cd ~ && sed -i 's/\*\*Cache\*\*//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")            
        else:
            os.system("echo '**cache**\n**Cache**' >> ~/.config/sbk/excluded")

        if self.builder.get_object("thumbnails").get_active() == True:
            os.system("cd ~ && sed -i 's/\*\*thumbs\*\*//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")
            os.system("cd ~ && sed -i 's/.thumbnails//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")                        
        else:
            os.system("echo '.thumbnails\n**thumbs**' >> ~/.config/sbk/excluded")        

        if self.builder.get_object("trash").get_active() == True:
            os.system("cd ~ && sed -i 's/.local\/share\/Trash//' '.config/sbk/excluded' && sed -i '/^$/d' '.config/sbk/excluded'")
        else:
            os.system("echo '.local/share/Trash' >> ~/.config/sbk/excluded")            
        
        # get backup file name:
        bk = open(os.environ['HOME']+'/.config/sbk/backupfile', 'w')
        bk.write(self.builder.get_object("filechooserbutton1").get_filename())
        bk.close()

        os.system("cat ~/.config/sbk/backupfile >> ~/.config/sbk/excluded")
        
        
        # backup script:
        os.system("touch ~/.config/sbk/backscript")
        backscript = open(os.environ['HOME']+'/.config/sbk/backscript', 'w')    
        backscript.write("""#!/bin/bash
echo "no" > ~/.config/sbk/backdone
a=$(xdg-user-dir HOME)
b=$(cat ~/.config/sbk/backupfile)
d=$(date '+%Y.%m.%d_%H-%M')
cd $a/.config/sbk/
tar -xvz -f $b
rsync -arbv --exclude-from="$a/.config/sbk/excluded" --delete "$a/" "$a/.config/sbk/bk"
find $a/.config/sbk/bk/ -name '*~' -exec rm '{}' \;
find $a/.config/sbk/bk/ -type d -empty -exec rmdir {} \;
mv $b ~/.local/share/Trash/files/
tar -cvz bk/ -f $b.updated.$d.sbk
rm -r $a/.config/sbk/bk/
echo "ok" > ~/.config/sbk/backdone 
exit 0
        """)
        backscript.close()

        os.system("gnome-terminal -e 'bash -c \"sh ~/.config/sbk/backscript ; exit ; exec bash\"'")

        UpdbkbDialog().show()


if __name__ == "__main__":
    dialog = UpdbkaDialog()
    dialog.show()
    Gtk.main()
